import { ElementType, ForwardRefExoticComponent, PropsWithoutRef, RefAttributes, RefObject } from 'react';
export interface PropItem<T> {
    key: string;
    value: T;
}
export declare type PropType<P> = P & {
    [key: string]: any;
};
export declare type Mappings<P> = {
    [K in keyof PropType<P>]?: string;
};
export declare function useWebComponent<T extends HTMLElement, P = {}>(props: PropType<P>, mapping?: Mappings<P>, eventsAreCamelCase?: boolean): [Partial<P>, RefObject<T>];
declare type HookProps<P> = PropType<P> & {
    mapping?: Mappings<P>;
    eventsAreCamelCase?: boolean;
};
export declare function withWebComponent<T extends HTMLElement, P = {}>(Component: ElementType<any>): ForwardRefExoticComponent<PropsWithoutRef<HookProps<P>> & RefAttributes<T>>;
export {};
