"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.withWebComponent = exports.useWebComponent = void 0;
var react_1 = __importStar(require("react"));
var react_merge_refs_1 = __importDefault(require("react-merge-refs"));
var util_1 = require("./util");
function useWebComponent(props, mapping, eventsAreCamelCase) {
    if (mapping === void 0) { mapping = {}; }
    if (eventsAreCamelCase === void 0) { eventsAreCamelCase = false; }
    var ref = react_1.createRef();
    var _a = react_1.useMemo(function () {
        var _a, _b;
        var events = [];
        var properties = [];
        var returnProps = {};
        for (var key in props) {
            var value = props[key];
            if (util_1.isEventListener(key, value))
                events.push({ key: (_a = mapping[key]) !== null && _a !== void 0 ? _a : util_1.listenerPropNameToEvent(key, eventsAreCamelCase), value: value });
            else if (util_1.isComplexProp(value))
                properties.push({ key: (_b = mapping[key]) !== null && _b !== void 0 ? _b : key, value: value });
            else
                returnProps[key] = value;
        }
        return [events, properties, returnProps];
    }, [props, mapping]), probableEvents = _a[0], probableProperties = _a[1], returnProps = _a[2];
    react_1.useLayoutEffect(function () {
        if ((ref === null || ref === void 0 ? void 0 : ref.current) == null)
            return;
        var current = ref.current;
        for (var _i = 0, probableEvents_1 = probableEvents; _i < probableEvents_1.length; _i++) {
            var event_1 = probableEvents_1[_i];
            current.addEventListener(event_1.key, event_1.value);
        }
        for (var _a = 0, probableProperties_1 = probableProperties; _a < probableProperties_1.length; _a++) {
            var property = probableProperties_1[_a];
            current[property.key] = property.value;
        }
        return function () {
            for (var _i = 0, probableEvents_2 = probableEvents; _i < probableEvents_2.length; _i++) {
                var event_2 = probableEvents_2[_i];
                current.removeEventListener(event_2.key, event_2.value);
            }
        };
    }, [probableEvents, probableProperties, ref]);
    return [returnProps, ref];
}
exports.useWebComponent = useWebComponent;
function genClassList(className, classProp) {
    return [className, classProp].filter(Boolean).join(' ');
}
function withWebComponent(Component) {
    var WebComponent = react_1.forwardRef(function (_a, ref) {
        var children = _a.children, _b = _a.mapping, mapping = _b === void 0 ? {} : _b, _c = _a.eventsAreCamelCase, eventsAreCamelCase = _c === void 0 ? false : _c, props = __rest(_a, ["children", "mapping", "eventsAreCamelCase"]);
        var className = props.className, classProp = props.class, restProps = __rest(props, ["className", "class"]);
        var _d = useWebComponent(restProps, mapping, eventsAreCamelCase), simpleProps = _d[0], innerRef = _d[1];
        return react_1.default.createElement(Component, __assign({}, simpleProps, { class: genClassList(className, classProp), ref: react_merge_refs_1.default([innerRef, ref]) }), children);
    });
    var displayName = util_1.isComponentType(Component) ? Component.displayName : Component;
    WebComponent.displayName = "WebComponent[" + (displayName !== null && displayName !== void 0 ? displayName : '') + "]";
    return WebComponent;
}
exports.withWebComponent = withWebComponent;
//# sourceMappingURL=index.js.map