"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isComplexProp = exports.listenerPropNameToEvent = exports.isEventListener = exports.isComponentType = void 0;
function isComponentType(x) {
    return x.displayName !== undefined;
}
exports.isComponentType = isComponentType;
function isEventListener(key, x) {
    return key.startsWith('on') && ((typeof x === 'object' && x.handleEvent != null) ||
        (typeof x === 'function' && x.length === 1));
}
exports.isEventListener = isEventListener;
function listenerPropNameToEvent(key, isCamel) {
    if (isCamel === void 0) { isCamel = false; }
    var eventName = key.replace('on', '');
    if (isCamel)
        return eventName.replace(/^./, function (char) { return char.toLowerCase(); });
    else {
        return eventName
            .replace(/([a-z0-9])([A-Z])/g, '$1-$2')
            .replace(/([A-Z])([A-Z])(?=[a-z])/g, '$1-$2')
            .toLowerCase();
    }
}
exports.listenerPropNameToEvent = listenerPropNameToEvent;
function isComplexProp(x) {
    return typeof x !== 'string' && typeof x !== 'boolean' && typeof x !== 'number';
}
exports.isComplexProp = isComplexProp;
//# sourceMappingURL=util.js.map